/******************************************************************************
	ȈՃCu(R\[o͏)֐
******************************************************************************/

#include <stdarg.h>

#ifdef USE_UART
/* CPU UARTo̓wb_ */
#include "cpu_uart.h"
#endif

/* ȈՃCuwb_ */
#include "tinylib.h"
#include "graphics.h"
#include "grphcon.h"

int _t_vsnprintf(char *buffer, unsigned long count, char *format, va_list argptr);

/* ----------------------------------------------------------------------- */

/* strlen */
int t_strlen(char *s)
{
  int l;
  l = 0;
  while(*s++) l++;
  return l;
}

/* strcmp */
int t_strcmp(char *s, char *d)
{
  while(*s == *d) {
    if(!*s) return 0;
    s++;
    d++;
  }
  return *s - *d;
}

/* strncpy */
char *t_strncpy(char *d, char *s, int n)
{
	int i;
	char *sd;
	sd=d;
	for(i = 0; i < n; i++) {
		*d=*s;
		d++;
		s++;
	}
	return sd;
}

/* memcmp */
int t_memcmp(char *s, char *d, int n)
{
  int i;
  for(i = 0; i < n; i++) {
    if(*s != *d) return *s - *d;
    s++;
    d++;
  }
  return 0;
}

/* memset */
char *t_memset(char *adr, char c, int n)
{
  int i;
  for(i = 0; i < n; i++) *adr++ = c;
  return adr;
}



/* ----------------------------------------------------------------------- */

/* Ȉprintf֐ */
int t_printf(char *format, ...)
{
	va_list argptr;
	int i;
	char buffer[MAX_PRINTFSIZE + 1];
	va_start(argptr, format);
	i=_t_vsnprintf(buffer, MAX_PRINTFSIZE, format, argptr);
	va_end(argptr);

#ifdef USE_UART
	CPU_UartPutsL(buffer, i);	/* CPU UART\ */
#endif
	GCON_putstrL(buffer, i);	/* OtBbNXR\[\ */

	return i;
}

/* sprintf֐ */
int t_sprintf(char *buffer, char *format, ...)
{
	va_list argptr;
	int i;
	va_start(argptr, format);
	i=t_vsprintf(buffer, format, argptr);
	va_end(argptr);
	return i;
}

/* vsprintf֐ */
int t_vsprintf(char *buffer, char *format, va_list argptr)
{
	return _t_vsnprintf(buffer, MAX_SPRINTFSIZE, format, argptr);
}

/* putch() */
int t_putch(int c)
{
#ifdef USE_UART
	CPU_UartPutch(c);	/* CPU UART\ */
#endif
	GCON_putc(c);		/* OtBbNXR\[\ */
	return c;
}

/* puts() */
int t_puts(char *str)
{
#ifdef USE_UART
	CPU_UartPuts(str);	/* CPU UART\ */
#endif
	GCON_putstr(str);	/* OtBbNXR\[\ */
	return 0;
}


#ifdef USE_UART
/* ----------------------------------------------------------------------- */
/* inputn */
int t_kbhit(void)
{
	int result;
	result=CPU_UartRecvCheck();
	return result;
}

int t_getch(void)
{
	int c;
	while(1) {	/* R\[͑҂ */
		if (CPU_UartRecvCheck()) {
			c = (int)CPU_UartGetch();
			break;
		}
	}
	return c;
}

/* GR[obNL̕ */
char *t_gets(char *buffer)
{
  int bufptr;
  int c;
  char *p;
  bufptr = 0; /*  */
  p = buffer;
  
  while(1) {
    /* R\[͑҂ */
    /* SERIAL/KBǂȂƁAŉiv[vɂȂ */
    while(!t_kbhit());
    c = t_getch();
    
    /* t_debug("%02X ", c); */
    
    if(c == 0x0d) { /* sŏI */
      *p = 0;
      t_putch(0x0d);
      break;
    }
    
    /* BS / DEL / R\[͂ɂ̓obt@폜 */
    if((c == 0x08)||(c == 0x7f)||(c == 0x1d)) {
      bufptr--;
      if(bufptr >= 0){
        *--p = 0;
      t_putch(0x08);
      } else {
        bufptr = 0;
      }
    } else {
      if(bufptr < MAX_GETSSIZE)
      t_putch(c);
      *p++ = c;
      bufptr++;
    }
  } /* while(1) */
  
/* t_debug("t_gets() : len = %d\n", bufptr); */
  
  return buffer;
}
#endif


/* ----------------------------------------------------------------------- */
/* printf͕ */

#define FC_MINUS (1)
#define FC_PLUS  (2)
#define FC_ZERO  (4)
#define FC_BLANK (8)
#define FC_SHARP (16)

/* ǂ */
int t_isdigit(char c)
{
  return ((c>='0')&&(c<='9'));
}

/* ӂꂽmȂ */
int _atoi_ptr(char **ptr)
{
  long l;
  int minus;
  char *p;
  p = *ptr;
  
  l = 0L;
  minus = 0;
  if(*p == '-') {
    minus = 1;
    p++;
  }
  
  while(t_isdigit(*p)){
    l *= 10;
    l += (*p-'0');
    p++;
  }
  if(minus) l = -l;
  *ptr = p; /* ߂ */
  /* printf("debug: %ld, %s\n", l, p); */
  return (int)l;
}

/* atoi */
int t_atoi(char *p)
{
	return _atoi_ptr(&p);
}

/* l當ɕϊ(t) */
int ntorstru(char *buf, unsigned long num, int base)
{
  unsigned long l, m;
  char *b0;
  char *cvt;
  char *cvt0 = "0123456789abcdef";
  char *cvt1 = "0123456789ABCDEF";
  
  b0 = buf; /* ۑ */
  cvt = cvt0;
  
  if(base<0) {
    cvt= cvt1;
    base = -base;
  }
  
  l = num;
  m = 0;
  
  if(l==0) *buf++ = '0';
  while(l) {
    m = l % base;
    l /= base;
    *buf++ = cvt[(int)m];
  }
  *buf = '\0';
  return buf-b0;
}


int _t_vsnprintf(char *buffer, unsigned long count, char *format, va_list argptr)
/*
  buffer
    o͂̊i[ʒu
  count
    ލő啶
  format
    ̎w
  argptr
    Xgւ̃|C^
*/
{
  char *ptr, *eob;
  unsigned flags;       /* format control : flag characters */
  int ef;
  char *pf;
  int width;
  int precision;
  int longf;
  int len, len2;
  char *s;
  int i;
  char numbuf[30];      /* longōŒłǂꂭ炢H */
  int symbol, minus;
  long v;
  unsigned long uv;
  
  ptr = buffer;         /* current output pointer */
  eob = (char *)(ptr + count -1); /* end of buffer */
  
  pf = format;
  while(*pf){
    if(ptr >= eob) break; /* obt@͂ݏoc */
    
    if(*pf != '%') {
      *ptr++ = *pf++;   /* %ȂƂ͂̂܂܏o */
      continue;
    }
    
    pf++; /* skip '%' */
    
    /* correct flags */
    flags = 0;
    ef = 0;
    while(!ef){
      switch(*pf){
        case '-': 
          flags |= FC_MINUS;
          break;
        case '+': 
          flags |= FC_PLUS;
          break;
        case '0': 
          flags |= FC_ZERO;
          break;
        case ' ': 
          flags |= FC_BLANK;
          break;
/*        case '#': 
          flags |= FC_SHARP;
          break;
*/
        default:
          ef = 1;
          break;
      }
      if(!ef) pf++;
    }
    
    /* width */
    width = -1; /* none */
    if(t_isdigit(*pf)) width = _atoi_ptr(&pf);
    
    /* printf("debug: %s\n", pf); */
    
    precision = -1; /* none */
    if(*pf == '.') {
      pf++;
      precision = _atoi_ptr(&pf);
    }
    
    /* size flag */
    longf = 0;
    if(*pf == 'l') {
      pf++;
      longf = 1;
    }
    
    /* output */
    switch(*pf++) {
      case '%':
        if(ptr < eob) *ptr++ = '%';
        continue;
        /* break; */
      
      case 'c': /* w͖cĂ */
        if(ptr < eob) *ptr++ = (char)va_arg(argptr, int);
        continue;
        /* break; */
      
      case 's':
        /* printf("debug: s\n"); */
        s = va_arg(argptr, char *);
        len = t_strlen(s);
        /* width.precision ɂ镝 */
        if((precision != -1)&&(len > precision)) len = precision;
        if(width == -1) width = len;
        if(width < len) width = len; /* So͂ */
        
        if(!(flags & FC_MINUS)) { /* El߂̏ꍇ */
          for(i = 0; i < width - len; i++) {
            if(ptr < eob) *ptr++ = ' ';
          }
        }
        for(i = 0; i < len; i++) *ptr++ = *s++; /* 񕔕o */
        if((flags & FC_MINUS)) { /* l߂̏ꍇ */
          for(i = 0; i < width - len; i++) {
            if(ptr < eob) *ptr++ = ' ';
          }
        }
        continue;
        /*break;*/
      
      
      case 'd':
      case 'i':
        if(longf) {
          v = (long)va_arg(argptr, long);
        } else {
          v = (int)va_arg(argptr, int);
        }
        minus = (v < 0)?1:0;
        if(minus) v = -v;
        len = ntorstru(numbuf, v, 10);
        break;
      
      case 'u':
        if(longf) {
          uv = (unsigned long)va_arg(argptr, unsigned long);
        } else {
          uv = (unsigned int)va_arg(argptr, unsigned int);
        }
        len = ntorstru(numbuf, uv, 10);
        minus = 0;
        break;
      
      case 'o':
        if(longf) {
          uv = (unsigned long)va_arg(argptr, unsigned long);
        } else {
          uv = (unsigned int)va_arg(argptr, unsigned int);
        }
        len = ntorstru(numbuf, uv, 8);
        minus = 0;
        break;
      
      case 'x':
        if(longf) {
          uv = (unsigned long)va_arg(argptr, unsigned long);
        } else {
          uv = (unsigned int)va_arg(argptr, unsigned int);
        }
        len = ntorstru(numbuf, uv, 16);
        minus = 0;
        break;
      
      case 'X':
        if(longf) {
          uv = (unsigned long)va_arg(argptr, unsigned long);
        } else {
          uv = (unsigned int)va_arg(argptr, unsigned int);
        }
        len = ntorstru(numbuf, uv, -16); /* base<0a-f啶*/
        minus = 0;
        break;
      
      default:
        /* tOƉ߂ꂽ͖̂߂Ȃc */
        if(ptr < eob) *ptr++ = '%';
        if(ptr < eob) *ptr++ = *(pf-1);
        continue;
        /*break;*/
    }
    
    /* ȉ͐l̂ */
    
    /* i = va_arg(argptr, int); */
    /* len = ntorstr(numbuf, i, 10); */
    
    len2 = len; /* ܂߂o͂ɕKvȒ */
    symbol = 0; /*  */
    if(minus) {
      symbol = '-';
    } else {
      if(flags & FC_BLANK) symbol = ' ';
      if(flags & FC_PLUS)  symbol = '+'; /* ' '㏑ */
    }
    if(symbol) len2++; 
    
    if(width < precision) width = precision; /* width.precision ʂĂȂcł̂H */
    if(width < len2) width = len2;           /* ŒKvȕɊg(wȂꍇ܂) */
    
    if(!(flags & FC_MINUS)) { /* 񂹂łȂꍇ */
      if(flags & FC_ZERO) { /* ZERO-FILL */
        if(symbol) {
          if(ptr < eob) *ptr++ = symbol;              /* Ăc */
        }
        for(i=0;i<width-len2;i++) {
          if(ptr < eob) *ptr++ = '0';  /* Ԃ0Ŗ߂ */
        }
      } else {                 /* 񂹂̏ꍇ */
        for(i=0;i<width-len2;i++) {
          if(ptr < eob) *ptr++ = ' ';  /* Ԃ󔒂Ŗ߂Ă */
        }
        if(symbol) {
          if(ptr < eob) *ptr++ = symbol;              /*  */
        }
      }
    } else {
      if(symbol) {
        if(ptr < eob) *ptr++ = symbol;                /* KvȂ畄o */
      }
    }
    for(i = len - 1; i >= 0; i--) {
      if(ptr < eob) *ptr++ = numbuf[i]; /* (t̕)o͂ */
    }
    if(flags & FC_MINUS) { /* 񂹂ŕw肪΋󔒂o͂ */
      for(i = 0; i < width - len2; i++) {
        if(ptr < eob) *ptr++ = ' ';
      }
    }
    
    /* continue; */
  } /* while(*pf) */
  *ptr = '\0';
  return (ptr - buffer); /* o͂ */
}
