/*
 * 摜\ɎgpTu[`Q
 */

/* CPUŗL@\`wb_ */
#include "cpu.h"

/* LCDpl[`wb_ */
#include "LCDpanel.h"

#include "viewer.h"

#define	DEFA_SHIFT	24
#define	ACOEF_SHIFT	16
#define	ARATE_SHIFT	8
#define	WE_SHIFT	7
#define	AST_SHIFT	4
#define	AMOD_SHIFT	1
#define	AEN_SHIFT	0

/*
 * C̃AhXݒ
 */
void LCD_Gra1Addr(PIXEL *base)
{
	*GROPSADR1    = (int) base;
	*GRCMEN1      = *GRCMEN1 | (1 << 31);	/* WX^l] */
}

/*
 * 㑤C̃AhXݒ
 */
void LCD_Gra2Addr(PIXEL *base)
{
	*GROPSADR2    = (int) base;
	*GRCMEN2      = *GRCMEN2 | (1 << 31);	/* WX^l] */
}


void LCD_Gra1Mode(int mode, int layer)
{
	*GRCMEN1      = layer;
	*GRCBUSCNT1   = mode;
	*GRCMEN1      = *GRCMEN1 | (1 << 31);	/* WX^l] */
}

void LCD_Gra2Mode(int mode, int layer)
{
	*GRCMEN2      = layer;
	*GRCBUSCNT2   = mode;
	*GRCMEN2      = *GRCMEN2 | (1 << 31);	/* WX^l] */
}

/*
 * \TCYݒ
 */
void LCD_Gra2Size(int width, int height)
{
	*GROPSWH2     = (height << 16) | width;
	*GRCMEN2      = *GRCMEN2 | (1 << 31);	/* WX^l] */
	while (*GRCMEN2 & (1<<31)) ;
}

void LCD_Gra2Region(int xoff, int yoff, int width, int height)
{
	*GROPEWH2 = (height << 16) | width;
	*GROPEDPHV2 = ((LCD_VERTICAL_BACK_PORCH - 1 + GRA2_VERTICAL_POS + yoff) << 16)
	               | (LCD_HORIZONTAL_BACK_PORCH - 16 + GRA2_HORIZONTAL_POS + xoff);
	*GROPEDPA2 = (0 << DEFA_SHIFT) | (1 << ACOEF_SHIFT)
			| (5 << ARATE_SHIFT) | (0 << AMOD_SHIFT);
	*GROPEDPA2 |= (1 << AEN_SHIFT) | (1 << WE_SHIFT);	/* Enable transfer */
	LCD_Gra2Size(LCD_WIDTH, LCD_HEIGHT);
}

void LCD_Gra2Area(int xoff, int yoff, int width, int height)
{
	*GROPSWH2     = (height << 16) | width;
	*GROPDPHV2    = ((LCD_VERTICAL_BACK_PORCH - 1 + GRA2_VERTICAL_POS + yoff) << 16)
	               | (LCD_HORIZONTAL_BACK_PORCH - 16 + GRA2_HORIZONTAL_POS + xoff);
	*GRCMEN2      = *GRCMEN2 | (1 << 31);	/* WX^l] */
	while (*GRCMEN2 & (1<<31)) ;
}

void LCD_Gra2Alpha(int val)
{
	*GROPEDPA2 = (val << DEFA_SHIFT) | (1 << ACOEF_SHIFT)
			| (5 << ARATE_SHIFT) | (0 << AMOD_SHIFT);
	*GROPEDPA2 |= (1 << AEN_SHIFT) | (1 << WE_SHIFT);	/* Enable transfer */
	delay_ms(20);
	while (*GROPEDPA2 & (1 << AST_SHIFT)) ;
}

void LCD_Gra2ANoAlpa()
{
	*GROPEDPA2 &= ~1;
	*GROPEDPA2 |= (1 << WE_SHIFT);	/* ] */
}

/*
 *   orientaiton ɉāÂ悤ȏԂŉf\B
 *
 *   1. EցA̍s牺̍sցB
 *       ------>
 *       |
 *       |
 *       V
 *
 *   2. E獶ցA̍s牺̍sցB
 *       <------
 *       |
 *       |
 *       V
 *
 *   3. E獶ցA̍s̍sցB
 *             ^
 *             |
 *             |
 *       <------
 *    
 *   4. EցA̍s̍sցB
 *       ^
 *       |
 *       |
 *       ------>
 *
 *   5. ォ牺ցA̗񂩂E̗ցB
 *       |------>
 *       |
 *       V
 *
 *   6. ォ牺ցAE̗񂩂獶̗ցB
 *       <------|
 *              |
 *              V
 *
 *   7. ցAE̗񂩂獶̗ցB
 *       <------^
 *              |
 *              |
 *
 *   8. ցA̗񂩂E̗ցB
 *      ^
 *      |
 *      |------->
 *
 */

void LCD_Draw_Line(int orientation, unsigned char *bp, int xoffset, int ypos, int width)
{
	PIXEL *pix;
        unsigned char rval, gval, bval;

	switch (orientation) {
	case 1:	/* EցA̍s牺̍sցB*/
	default:
	    pix = (PIXEL *)GRPH_Buffer + ypos * LCD_WIDTH + xoffset;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix++ = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
	    }
	    break;
	case 2: /* E獶ցA̍s牺̍sցB*/
	    pix = (PIXEL *)GRPH_Buffer + (ypos + 1) * LCD_WIDTH - xoffset - 1;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix-- = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
	    }
	    break;
	case 3: /* E獶ցA̍s̍sցB*/
	    pix = (PIXEL *) GRPH_Buffer + (LCD_HEIGHT - ypos)* LCD_WIDTH - 1 - xoffset;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix-- = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
	    }
	    break;
	case 4: /* EցA̍s̍sցB*/
	    pix = (PIXEL *) GRPH_Buffer + (LCD_HEIGHT -1 - ypos)* LCD_WIDTH + xoffset;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix++ = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
	    }
	    break;
	case 5: /* ォ牺ցA̗񂩂E̗ցB*/
	    pix = (PIXEL *) GRPH_Buffer + ypos + (LCD_HEIGHT * xoffset);
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
		pix += LCD_WIDTH;
	    }
	    break;
	case 6: /* ォ牺ցAE̗񂩂獶̗ցB*/
	    pix = (PIXEL *) GRPH_Buffer + (LCD_WIDTH -1) - ypos + (LCD_HEIGHT * xoffset);
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
		pix += LCD_WIDTH;
	    }
	    break;
	case 7:	/* ցAE̗񂩂獶̗ցB*/
	    pix = (PIXEL *) GRPH_Buffer - 1 + (LCD_HEIGHT - xoffset)*LCD_WIDTH - ypos;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
		pix -= LCD_WIDTH;
	    }
	    break;
	case 8:	/* ցA̗񂩂E̗ցB*/
	    pix = (PIXEL *) GRPH_Buffer + (LCD_HEIGHT - 1 - xoffset)*LCD_WIDTH + ypos;
	    while (width > 0) {
		rval = *bp++;
		gval = *bp++;
		bval = *bp++;
		*pix = ((rval >> 3) << 11) |
			 ((gval >> 2) << 5) | (bval >> 3);
		width--;
		pix -= LCD_WIDTH;
	    }
	    break;
	}
}
