/*----------------------------------------------------------------------*/
/* FatFsW[ TvvO              (C)T.AKAMATSU, 2010  */
/*----------------------------------------------------------------------*/
/* C^[tF[Xt^SH7262TvvO                     */
/* R\[o: SCI2 N81 38400bps                                  */
/*----------------------------------------------------------------------*/
/* 2010.6.10  d䃌WX^̐ݒ~XC
/ 
*/


#include "cpu.h"
#include "viewer.h"
#include "scif.h"
#include "monitor.h"
#include "diskio.h"
#include "ff.h"
#include "LCDpanel.h"
#include "graphics.h"
#include "grphcon.h"
#include "event.h"
#include "exif.h"
#include "dcf.h"
#include "TouchPanel.h"

#define	PCLK	24000000UL

void SetImask (unsigned long);	/* Set mask level (asmfunc.s) */

/*---------------------------------------------------------*/
/* [NGA                                            */
/*---------------------------------------------------------*/

FATFS Fatfs;				/* t@CVXeIuWFNg */

volatile UINT Timer;		/* ptH[}X^C} (1kHzZ) */
volatile UINT jpeg_timer;
volatile UINT use_key;		/* SW ܂̓^b`pl̂ǂg */

#define	EVQLEN	30

volatile UINT time_tick;
volatile evinfo *ev_top;
volatile evinfo *ev_tail;
static volatile UINT last_tp_val, last_down_time;

static evinfo qdata[EVQLEN];

UINT get_time_tick()
{
    return time_tick;
}

static void ev_add(int event, int tpval)
{
    ev_tail->ev_type = event;
    ev_tail->ev_time = time_tick;
    ev_tail->tp_val = tpval;
    ev_tail++;
    if (ev_tail == &qdata[EVQLEN]) ev_tail = &qdata[0];
}

evinfo *ev_get(int do_wait)
{
    volatile evinfo *evp;

    while (1) {
	evp = ev_top;
	if (evp != ev_tail)
	    break;
	if (!do_wait) return (evinfo*)0;
	delay_us(3);
    }
    ev_top++;
    if (ev_top == &qdata[EVQLEN]) ev_top = &qdata[0];
    return (evinfo *)evp;
}

void ev_flush()
{
    while (ev_get(0))
	delay_ms(2);
}

void ev_wait(int wevent)
{
	evinfo *evp;

	do {
		evp = ev_get(1);
	} while (evp->ev_type != wevent);
}

UINT jpeg_time(int flag)
{
    UINT val;

    val = jpeg_timer;
    if (flag == 0)
	jpeg_timer = 0;
    return val;
}

#define	PH0_MASK	0x01
#define	PH1_MASK	0x02
#define	PC7_MASK	0x80
#define	PC6_MASK	0x40
#define	PC5_MASK	0x20
#define	PC2_MASK	0x04

void key_timerproc()
{
    static BYTE prev_scan, key_state;
    BYTE work, change;

    work = (*PCPR0 & (PC7_MASK|PC6_MASK|PC5_MASK|PC2_MASK)) | (*PHPR0 & (PH0_MASK|PH1_MASK));
    if (work == prev_scan) {
	change = key_state;
	key_state = work;	/* L[ԂXV */
	change = change ^ work;
	if (change) {		/* ԕωɉCxg𐶐 */
	    if ((change & PH0_MASK) && !(work & PH0_MASK)) {
		ev_add(EV_PH0_DOWN, 0);
	    }
	    if ((change & PH1_MASK) && !(work & PH1_MASK)) {
		ev_add(EV_PH1_DOWN, 0);
	    }
	    if ((change & PC2_MASK) && !(work & PC2_MASK)) {
		ev_add(EV_PC2_DOWN, 0);
	    }
	    if ((change & PC5_MASK) && !(work & PC5_MASK)) {
		ev_add(EV_PC5_DOWN, 0);
	    }
	    if ((change & PC6_MASK) && !(work & PC6_MASK)) {
		ev_add(EV_PC6_DOWN, 0);
	    }
	    if ((change & PC7_MASK) && !(work & PC7_MASK)) {
		ev_add(EV_PC7_DOWN, 0);
	    }
	}
    }
    prev_scan = work;
}

/*---------------------------------------------------------*/
/* 1000HzC^[o^C} (CMT0)                         */
/*---------------------------------------------------------*/

void Isr_CMI0 (void)
{
	static int div10, b;
	UINT tp_val;


	*CMCSR0 &= ~0x0080;			/* CMT0荞݃tÕNA */

	time_tick++;
	Timer++;
	jpeg_timer++;

	if ((++b % 0x400) == 0)		/* 1024tickLED1𔽓] */
		*PCDR0 ^=  0x0100;
	if (use_key < 0)
		return;

	if (!use_key && ((b % 5) == 0)) { /* 5ms ԊuŃ^b`pl */
		TOUCH_Interrupt();
		if (TOUCH_GetPenDown()) {
			tp_val = TOUCH_GetXY(0);
			if ((tp_val ^ last_tp_val) & TOUCH_DOWNMASK) {
			    if (tp_val & TOUCH_DOWNMASK) {
				ev_add(EV_PENDOWN, tp_val);
				last_down_time = time_tick;
			    } else {
				last_tp_val &= ~(TOUCH_DOWNMASK);
				ev_add(EV_PENUP, tp_val);
			    }
			}
			last_tp_val = tp_val;
		} else if (TOUCH_GetPDVar() ==0) {
			if (last_tp_val & TOUCH_DOWNMASK) {
			    last_tp_val &= ~(TOUCH_DOWNMASK);
			    ev_add(EV_PENUP, last_tp_val);
			}
		}
	}

	if (++div10 >= 10) {
		div10 = 0;
		disk_timerproc();		/* fBXN^C} (100Hz) */
		if (use_key) key_timerproc();
	}
}

void delay_ms (					/* msPʂ̃fBC */
	UINT ms
)
{
	for (Timer = 0; Timer < ms; ) ;
}


/*---------------------------------------------------------*/
/* ytF̏                                */
/*---------------------------------------------------------*/

#define SetCCR1(x) ((void(*)(DWORD))((DWORD)SetCCR1_proc + 0x20000000))(x)	/* CCR1ւ̏(LbVGAŎs) */
void SetCCR1_proc (DWORD val)	/* CCR1ւ̏ */
{
	*CCR1; *CCR1;
	*CCR1 = val;
	*CCR1; *CCR1;
}

static
void IoInit (void)
{
	*FRQCR = 0x1104;			/* NbNݒ: I=144M, B=48M, P=24M */

	SetCCR1(0x0000090B);	/* LbVL */

	*PCIOR0 |= 0x0100;		/* PC8:LEDo */
	*PCDR0 |=  0x0100;		/* LED off */

	*PHCR0 = 0;


	scif2_init();			/* SCI2: N81,38400bps */

	/* CMT0̏(1kHzC^[o^C}) */
	*STBCR7 &= ~0x04;		/* CMTgp */
	*CMCNT0 = 0;			/* JE^NA */
	*CMCOR0 = PCLK / 8 / 1000 - 1;	/* l̐ݒ */
	*CMCSR0 = 0x0040;		/* 荞݋, NbN:PCLK/8 */
	*CMSTR  |= 0x0001;		/* JEgJn */
	*IPR10 = (*IPR10 & 0xFF0F) | 0x0020;	/* 荞݃x:2 */

	*IBNR = 0x4000;				/* WX^oNgp */
	SetImask(0);			/* S荞݋ */
}

/*
 * y_Eop|[gLɂƁAX2ω邩ǂ𒲂ׂ
 * X2 L ɂȂ΁A^b`plpɃWpݒ肳ĂB
 * H ̂܂܂ł΁AXCb`pɃWpݒ肳ĂƔfB
 * : plɃ^b`ꂽԂŌĂяoƁAXCb`ƔfĂ܂B
 */
int DeviceCheck()
{
	int device = 0;

#ifdef BOARD_HOKUTO
	/* y_Eopv_ER|[gPE3='L' */
	*PECR0 = *PECR0  & 0x0FFF;	/* GPIOI */
	*PEIOR0= *PEIOR0 | 0x0008;	/* PE3 o */
	*PEDR0 = *PEDR0  & 0xFFF7;	/* PE3 o̓WX^'L' */
#endif
#ifdef BOARD_WAKAMATSU
	/* y_Eopv_ER|[gPF7='L' */
	*PFCR1 = *PFCR1  & 0x0FFF;	/* GPIOI */
	*PFIOR0= *PFIOR0 | 0x0080;	/* PF7 o */
	*PFDR0 = *PFDR0  & 0xFF7F;	/* PF7 o̓WX^'L' */
#endif

	delay_ms(10);

	/* LCD_X2(|[gPC6)Ԕ */
	if (*PCPR0 & (1 << 6)) {
	    /* SW IĂ */
	    device = 1;
	} else {
	    /* ^b`plIĂBs */
	    TOUCH_Initialize();
	}
	return device;
}


void SD_Prompt()
{
	GCON_set_color(C_BLACK|ALPHA15, C_LIME|ALPHA15);
	GCON_locate(3, 6);
	GCON_putstr("                                 ");
	GCON_locate(3, 7);
	GCON_putstr("      SDJ[h}āA       ");
	GCON_locate(3, 8);
	if (use_key) {
	    GCON_putstr("   I{^ĂB  ");
	} else {
	    GCON_putstr("    ʂɃ^b`ĂB   ");
	}
	GCON_locate(3, 9);
	GCON_putstr("                                 ");
	GCON_set_color(C_WHITE|ALPHA15, C_BLACK);
}

#ifdef NO_SERIAL
void dummy_put(BYTE d)
{
}
#endif

int main (void)
{
	evinfo *evp;
	int event;

	ev_tail = ev_top = &qdata[0];
	use_key = -1;			/* ̓foCXI */

	IoInit();			/* ӃW[̏ */
	use_key = DeviceCheck();

	xfunc_in = scif2_get;	/* R\[SCIF2Ɍ */
#ifdef NO_SERIAL
	xfunc_out = dummy_put;
#else
	xfunc_out = scif2_put;
#endif
#ifdef DEBUG
	if ((*PCPR0 & PC6_MASK) == 0) {
	    slow_slide = 1;
	}
#endif

	xputs("Program started.\n");
	GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);
	GRPH_Initialize();
	GRPH_Clear(C_BLACK);
	GCON_SelectPlane((PIXEL *)GRA2_VRAM_BASE);
	GCON_Initialize();
	GCON_cursor_off();
	GCON_clear();



	delay_ms(500);

	/* Flush any pending events */
	ev_flush();

	while (1) {
	    SD_Prompt();
	    if (use_key) {
	        do {
		    evp = ev_get(1);
		    event = evp->ev_type;
	        } while ((event != EV_SEL_RIGHT) && (event != EV_SEL_LEFT));
	    } else {
		do {
		    evp = ev_get(1);
		} while (evp->ev_type != EV_PENDOWN);
	    }
	    

	    GCON_clear();

	    f_mount(0, &Fatfs);

	    GRPH_SelectPlane((PIXEL *)GRA2_VRAM_BASE);
	    GRPH_Clear(C_BLACK);
	    GRPH_SelectPlane((PIXEL *)GRA1_VRAM_BASE);

	    dcf_viewer();
	}
}
