/*
 * XChV[̏
 */
#include "cpu.h"
#include "viewer.h"
#include "ff.h"
#include "grphcon.h"
#include "exif.h"
#include "LCDpanel.h"
#include "dcf.h"
#include "tinylib.h"
#include "event.h"
#include "monitor.h"

#define	DEFA_SHIFT	24
#define	ACOEF_SHIFT	16
#define	ARATE_SHIFT	8
#define	WE_SHIFT	7
#define	AST_SHIFT	4
#define	AMOD_SHIFT	1
#define	AEN_SHIFT	0

void slide_delay()
{
    if (slow_slide) {
	delay_ms(50);
    }
}

/*
 * XChV[\Ȃ
 *   cpos: \Jn摜ԍ (0..11)
 */
int slide_show(int cpos)
{
    struct dcf_file_info *pdcf;
    EXIF *exif;
    int nfiles, npos;
    int mode;
    int first_time;
    PIXEL *lower, *upper, *work, *active;
    int width, height;
    int xpos, ypos;
    evinfo *evp;

    lower = (PIXEL *)GRA1_VRAM_BASE;
    upper = (PIXEL *)GRA2_VRAM_BASE;
    /* Clear GRA1 area */
    GRPH_SelectPlane(lower);
    GRPH_Clear(C_BLACK);		/* OtBbNẌNA */
    GCON_clear();
    first_time = 1;
    mode = 0;
    *GROPBASERGB1 = 0x00000000;	/* OtBbNX摜OF(Black) */


    LCD_Gra1Mode(BUSCNT_RGB565, C_LAYER);

    do {
	if (first_time) {
	    GCON_locate(15, 7);
	    t_printf("...");
	    first_time = 0;
	    active = upper;
	}
	if (mode < 5) {
	    /* V摜̃CɓWJKv */
	    if (active == lower) {
		/* ݁ÃC̉摜\B
		 * ̃C̉摜̃CɈړĕ\B
		 */
		LCD_Gra2Mode(BUSCNT_RGB565, L_LAYER);	/* \ */
		LCD_Gra2Addr(lower);	/* 㑤̃AhXtւ */
		work = upper;		/* ㉺ */
		upper = lower;
		lower = work;
		LCD_Gra2Alpha(255);	/* 㑤̃lݒ */
	    }
	    LCD_Gra1Addr(lower);	/* ̃AhXtւ */
	    LCD_Gra2Mode(BUSCNT_RGB565, C_LAYER);	/* 㑤\ */
	    active = lower;
 	} else {
	    /* V摜̃CɓWJKv */
	    if (active == upper) {
		/* ݁ÃC̉摜\B
		 * ̃C̉摜̃CɈړĕ\B
		 */
		LCD_Gra2Mode(BUSCNT_RGB565, C_LAYER);	/* 㑤\ */
		LCD_Gra1Addr(upper);	/* ̃AhXtւ */
		work = upper;		/* ㉺ */
		upper = lower;
		lower = work;
	    }
	    LCD_Gra2Mode(BUSCNT_RGB565, L_LAYER);	/* \ */
	    LCD_Gra2Addr(upper);	/* 㑤̃AhXtւ */
	    LCD_Gra2Alpha(255);
	    active = upper;
	    LCD_Gra2Size(0, 0);
	}

	/*
	 * \摜ւ̃|C^
	 */
        pdcf = &dcf_files[cpos];
        exif = &pdcf->exif_info;

        /*
         * active őIv[͌ݔ\ɂȂĂ̂ŁA
         *  JPEG 摜WJ
         */
	GRPH_SelectPlane(active);

        if (expand_jpeg(pdcf->pathname, exif->orientation)) {
	    if (slow_slide) {
		xprintf("*** SLIDE EFECT!! ***\n");
		delay_ms(500);
	    }
	    LCD_Gra2Mode(BUSCNT_RGB565, C_LAYER|L_LAYER);
	    switch (mode) {
	    case 0:
		/*
                 * 㑤̃CɌÂ摜AɐV摜ĂB
		 * 㑤C̃lZĂ
		 */
		if (slow_slide) {
		    *GROPEDPA2 = (255 << DEFA_SHIFT) | (2 << ACOEF_SHIFT)
			| (2 << ARATE_SHIFT) | (2 << AMOD_SHIFT);
		} else {
		    *GROPEDPA2 = (255 << DEFA_SHIFT) | (2 << ACOEF_SHIFT)
			| (0 << ARATE_SHIFT) | (2 << AMOD_SHIFT);
		}
		*GROPEDPA2 |= (1 << AEN_SHIFT) | (1 << WE_SHIFT);	/* ]Jn */
		while (!(*GROPEDPA2 & (1<<AST_SHIFT))) ;		/* ]JnmF */
		while (*GROPEDPA2 & (1<<AST_SHIFT)) ;		/* ]ImF */
		break;
	    case 1:
		/* EւƃCvAEg */
		for (width = 0; width <= LCD_WIDTH; width += 8) {
		    LCD_Gra2Region(0, 0, width, LCD_HEIGHT);
		    slide_delay();
		}
		break;
	    case 2:
		/* ォ牺ւƃCvAEg */
		for (height = 0; height <= LCD_HEIGHT; height += 8) {
		    LCD_Gra2Region(0, 0, LCD_WIDTH, height);
		    slide_delay();
		}
		break;
	    case 3:
		/* Â摜̃tF[hAEg */
		LCD_Gra1Mode(BUSCNT_RGB565, 0);		/* V摜͕\֎~Ă */
		*GROPEDPA2 = (255 << DEFA_SHIFT) | (2 << ACOEF_SHIFT)
			| (0 << ARATE_SHIFT) | (2 << AMOD_SHIFT);
		*GROPEDPA2 |= (1 << AEN_SHIFT) | (1 << WE_SHIFT);	/* ]Jn */
		while (!(*GROPEDPA2 & (1<<AST_SHIFT))) ;	/* ]JnmF */
		while (*GROPEDPA2 & (1<<AST_SHIFT)) ;	/* ]ImF */

		/* V摜̃tF[hC */
		LCD_Gra1Mode(BUSCNT_RGB565, C_LAYER | L_LAYER);	     /* V摜\ */
		*GROPEDPA1 = (0 << DEFA_SHIFT) | (2 << ACOEF_SHIFT)
			| (0 << ARATE_SHIFT) | (1 << AMOD_SHIFT);
		*GROPEDPA1 |= (1 << AEN_SHIFT) | (1 << WE_SHIFT);	/* ]Jn */
		while (!(*GROPEDPA1 & (1<<AST_SHIFT))) ;	/* ]JnmF */
		while (*GROPEDPA1 & (1<<AST_SHIFT)) ;	/* ]ImF */
		break;
	    case 4:
		/* lO֌ăCvAEg */
		xpos = LCD_WIDTH/2; ypos = LCD_HEIGHT/2;
		width = 0; height = 0;
		while (width <= LCD_WIDTH) {
		    LCD_Gra2Region(xpos, ypos, width, height);
		    xpos -= 4; ypos -= 3;
		    width += 8; height += 6;
		    slide_delay();
		}
		break;
	    case 5:
		height = 0;
		for (ypos = LCD_HEIGHT/2; ypos >= 0; ypos -= 2) {
		    LCD_Gra2Area(0, ypos, LCD_WIDTH, height);
		    height += 4;
		    slide_delay();
		}
		break;
	    case 6:
		/* E獶փXChC */
		for (xpos = 0; xpos <= LCD_WIDTH; xpos += 8) {
		    LCD_Gra2Area(LCD_WIDTH - xpos, 0, xpos, LCD_HEIGHT);
		    slide_delay();
		}
		break;
	    case 7:
		/* փXChC */
		for (ypos = LCD_HEIGHT; ypos >= 0; ypos -= 4) {
		    LCD_Gra2Area(0, ypos, LCD_WIDTH, LCD_HEIGHT - ypos);
		    slide_delay();
		}
		break;
	    case 8:
		width = 0;
		for (xpos = LCD_WIDTH/2; xpos >= 0; xpos -= 4) {
		    LCD_Gra2Area(xpos, 0, width, LCD_HEIGHT);
		    width += 8;
		    slide_delay();
		}
		break;
	    case 9:
		/* E獶փXChC */
		xpos = LCD_WIDTH; ypos = LCD_HEIGHT;
		width = height = 0;
		while (width <= LCD_WIDTH) {
		    LCD_Gra2Area(xpos, ypos, width, height);
		    xpos -= 8; width += 8;
		    ypos -= 6; height += 6;
		    slide_delay();
		}
		break;
	    }
	} else {
	    GCON_SelectPlane(upper);
	    GCON_Initialize();
	    GCON_locate(5, 6);
	    t_puts(pdcf->pathname);
	    GCON_locate(5, 8);
	    t_puts("摜傫ĕ\\ł܂");
	    active = upper;
	}
	mode++;
	mode %= 10;
	jpeg_time(0);

        cpos++;	/* ̉摜ԍ */
        if (cpos == dcf_info.nfiles) {
	    /* y[W̏IɒB */
            npos = dcf_info.findex + cpos;
	    if (npos == dcf_info.num_files) {
		/* S摜t@C̍ŌɒB̂ŁAŏɖ߂ */
	        nfiles = seek_DCF(0);
	    } else {
		/* ̃y[Wǂݍ */
	        nfiles = seek_DCF(npos);
	    }
	    cpos = 0;
        }

        /*
         * SLIDE_PERIODԂEGCgB
         * ^b`ꂽAXChV[𒆒fB
         */
	while (jpeg_time(1) < SLIDE_PERIOD) {
	    evp = ev_get(0);
	    if (evp && evp->ev_type != EV_PENUP) break;
	}
    } while (evp == 0);

    ev_flush();
    LCD_Gra1Addr((PIXEL *)GRA1_VRAM_BASE);
    LCD_Gra2Addr((PIXEL *)GRA2_VRAM_BASE);
    LCD_Gra1Mode(BUSCNT_RGB565, C_LAYER);
    LCD_Gra2Mode(BUSCNT_aRGB4444, C_LAYER|L_LAYER);
    LCD_Gra2ANoAlpa();
    return cpos;
}
